<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: handler-objects.inc.php 37 2009-12-31 02:02:43Z egalstad $

require_once(dirname(__FILE__).'/common.inc.php');


// GENERIC OBJECTS *************************************************************************
function fetch_objects(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;

	// default to only showing active objects unless overriden by request
	if(!isset($request["is_active"]))
		$request["is_active"]=1;

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["objects"].".instance_id",
		"object_id" => $db_tables[DB_NDOUTILS]["objects"].".object_id",
		"objecttype_id" => $db_tables[DB_NDOUTILS]["objects"].".objecttype_id",
		"name1" => $db_tables[DB_NDOUTILS]["objects"].".name1",
		"name2" => $db_tables[DB_NDOUTILS]["objects"].".name2",
		"is_active" => $db_tables[DB_NDOUTILS]["objects"].".is_active",
		);
	$objectauthfields=array(
		"object_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetObjects'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	$sql=generate_sql_query(DB_NDOUTILS,$args);
	
 	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		echo "<objectlist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			while(!$rs->EOF){

				echo "  <object id='".db_field($rs,'object_id')."'>\n";
				xml_db_field(2,$rs,'instance_id');
				xml_db_field(2,$rs,'object_id');
				xml_db_field(2,$rs,'objecttype_id');
				xml_db_field(2,$rs,'is_active');
				xml_db_field(2,$rs,'name1');
				xml_db_field(2,$rs,'name2');
				echo "  </object>\n";

				$rs->MoveNext();
				}
			}

		echo "</objectlist>\n";
		}
	}

// HOSTS *************************************************************************
function fetch_hosts(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;
	
	$brevity=intval(grab_request_var("brevity",0));

	// default to only showing active objects unless overriden by request
	if(!isset($request["is_active"]))
		$request["is_active"]=1;

	// generate query
	$fieldmap=array(
		"host_name" => $db_tables[DB_NDOUTILS]["objects"].".name1",
		"instance_id" => $db_tables[DB_NDOUTILS]["objects"].".instance_id",
		"host_id" => $db_tables[DB_NDOUTILS]["objects"].".object_id",
		"is_active" => $db_tables[DB_NDOUTILS]["objects"].".is_active",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"host_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetHosts'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	$sql=generate_sql_query(DB_NDOUTILS,$args);
	//echo "SQL: ".$sql."<BR>\n";
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<hostlist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			while(!$rs->EOF){
				
				echo "  <host id='".db_field($rs,'object_id')."'>\n";
				xml_db_field(2,$rs,'instance_id');
				xml_db_field(2,$rs,'name1','host_name');
				xml_db_field(2,$rs,'is_active');
				xml_db_field(2,$rs,'config_type');
				xml_db_field(2,$rs,'alias');
				xml_db_field(2,$rs,'display_name');
				xml_db_field(2,$rs,'address');
				if($brevity<1){
					xml_db_field(2,$rs,'check_interval');
					xml_db_field(2,$rs,'retry_interval');
					xml_db_field(2,$rs,'max_check_attempts');
					xml_db_field(2,$rs,'first_notification_delay');
					xml_db_field(2,$rs,'notification_interval');
					xml_db_field(2,$rs,'passive_checks_enabled');
					xml_db_field(2,$rs,'active_checks_enabled');
					xml_db_field(2,$rs,'notifications_enabled');
					xml_db_field(2,$rs,'notes');
					xml_db_field(2,$rs,'notes_url');
					xml_db_field(2,$rs,'action_url');
					xml_db_field(2,$rs,'icon_image');
					xml_db_field(2,$rs,'icon_image_alt');
					xml_db_field(2,$rs,'statusmap_image');
					}
				echo "  </host>\n";

				$rs->MoveNext();
				}
			}

		echo "</hostlist>\n";
		}
	}
	
	
// SERVICES *************************************************************************
function fetch_services(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;
	
	$brevity=intval(grab_request_var("brevity",0));

	// default to only showing active objects unless overriden by request
	if(!isset($request["is_active"]))
		$request["is_active"]=1;

	// generate query
	$fieldmap=array(
		"host_name" => $db_tables[DB_NDOUTILS]["objects"].".name1",
		"service_description" => $db_tables[DB_NDOUTILS]["objects"].".name2",
		"instance_id" => $db_tables[DB_NDOUTILS]["objects"].".instance_id",
		"service_id" => $db_tables[DB_NDOUTILS]["services"].".service_object_id",
		"host_id" => $db_tables[DB_NDOUTILS]["services"].".host_object_id",
		"is_active" => $db_tables[DB_NDOUTILS]["objects"].".is_active",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"service_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetServices'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	$sql=generate_sql_query(DB_NDOUTILS,$args);
	//echo "SQL: ".$sql."<BR>\n";
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<servicelist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			while(!$rs->EOF){
				
				echo "  <service id='".db_field($rs,'object_id')."'>\n";
				xml_db_field(2,$rs,'instance_id');
				xml_db_field(2,$rs,'name1','host_name');
				xml_db_field(2,$rs,'name2','service_description');
				xml_db_field(2,$rs,'is_active');
				xml_db_field(2,$rs,'config_type');
				xml_db_field(2,$rs,'display_name');
				if($brevity<1){
					xml_db_field(2,$rs,'check_interval');
					xml_db_field(2,$rs,'retry_interval');
					xml_db_field(2,$rs,'max_check_attempts');
					xml_db_field(2,$rs,'first_notification_delay');
					xml_db_field(2,$rs,'notification_interval');
					xml_db_field(2,$rs,'passive_checks_enabled');
					xml_db_field(2,$rs,'active_checks_enabled');
					xml_db_field(2,$rs,'notifications_enabled');
					xml_db_field(2,$rs,'notes');
					xml_db_field(2,$rs,'notes_url');
					xml_db_field(2,$rs,'action_url');
					xml_db_field(2,$rs,'icon_image');
					xml_db_field(2,$rs,'icon_image_alt');
					}
				echo "  </service>\n";

				$rs->MoveNext();
				}
			}

		echo "</servicelist>\n";
		}
	}
	
	
// CONTACTS *************************************************************************
function fetch_contacts(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;

	$brevity=intval(grab_request_var("brevity",0));

	// default to only showing active objects unless overriden by request
	if(!isset($request["is_active"]))
		$request["is_active"]=1;

	// generate query
	$fieldmap=array(
		"contact_name" => $db_tables[DB_NDOUTILS]["objects"].".name1",
		"instance_id" => $db_tables[DB_NDOUTILS]["objects"].".instance_id",
		"contact_id" => $db_tables[DB_NDOUTILS]["objects"].".object_id",
		"is_active" => $db_tables[DB_NDOUTILS]["objects"].".is_active",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"contact_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetContacts'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	$sql=generate_sql_query(DB_NDOUTILS,$args);
	//echo "SQL: ".$sql."<BR>\n";
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<contactlist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			while(!$rs->EOF){
				
				echo "  <contact id='".db_field($rs,'object_id')."'>\n";
				xml_db_field(2,$rs,'instance_id');
				xml_db_field(2,$rs,'name1','contact_name');
				xml_db_field(2,$rs,'is_active');
				xml_db_field(2,$rs,'config_type');
				xml_db_field(2,$rs,'alias');
				xml_db_field(2,$rs,'email_address');
				if($brevity<1){
					xml_db_field(2,$rs,'pager_address');
					xml_db_field(2,$rs,'host_timeperiod_object_id','host_timeperiod_id');
					xml_db_field(2,$rs,'service_timeperiod_object_id','service_timeperiod_id');
					xml_db_field(2,$rs,'host_notifications_enabled');
					xml_db_field(2,$rs,'service_notifications_enabled');
					xml_db_field(2,$rs,'can_submit_commands');
					xml_db_field(2,$rs,'notify_service_recovery');
					xml_db_field(2,$rs,'notify_service_warning');
					xml_db_field(2,$rs,'notify_service_unknown');
					xml_db_field(2,$rs,'notify_service_critical');
					xml_db_field(2,$rs,'notify_service_flapping');
					xml_db_field(2,$rs,'notify_service_downtime');
					xml_db_field(2,$rs,'notify_host_recovery');
					xml_db_field(2,$rs,'notify_host_down');
					xml_db_field(2,$rs,'notify_host_unreachable');
					xml_db_field(2,$rs,'notify_host_flapping');
					xml_db_field(2,$rs,'notify_host_downtime');
					}
				echo "  </contact>\n";

				$rs->MoveNext();
				}
			}

		echo "</contactlist>\n";
		}
	}


// HOSTGROUPS *************************************************************************
function fetch_hostgroups(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;

	$brevity=intval(grab_request_var("brevity",0));
	
	// default to only showing active objects unless overriden by request
	if(!isset($request["is_active"]))
		$request["is_active"]=1;

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["objects"].".instance_id",
		"hostgroup_id" => $db_tables[DB_NDOUTILS]["objects"].".object_id",
		"hostgroup_name" => $db_tables[DB_NDOUTILS]["objects"].".name1",
		"is_active" => $db_tables[DB_NDOUTILS]["objects"].".is_active",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"hostgroup_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetHostGroups'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	$sql=generate_sql_query(DB_NDOUTILS,$args);
	//echo "SQL: ".$sql."<BR>\n";
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<hostgrouplist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			while(!$rs->EOF){
				
				echo "  <hostgroup id='".db_field($rs,'object_id')."'>\n";
				xml_db_field(2,$rs,'instance_id');
				xml_db_field(2,$rs,'name1','hostgroup_name');
				xml_db_field(2,$rs,'is_active');
				xml_db_field(2,$rs,'config_type');
				xml_db_field(2,$rs,'alias');
				echo "  </hostgroup>\n";

				$rs->MoveNext();
				}
			}

		echo "</hostgrouplist>\n";
		}
	}


// HOSTGROUP MEMBERS **********************************************************************
function fetch_hostgroupmembers(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;
	
	$brevity=intval(grab_request_var("brevity",0));

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["hostgroups"].".instance_id",
		"hostgroup_id" => $db_tables[DB_NDOUTILS]["hostgroups"].".hostgroup_object_id",
		"hostgroup_name" => "obj1.name1",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"hostgroup_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetHostGroupMembers'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	// override sort order, as its critical in the membership list logic below...
	$request["orderby"]="hostgroup_name";

	$sql=generate_sql_query(DB_NDOUTILS,$args);
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<hostgrouplist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			$last_id=0;
			$this_id=0;
			while(!$rs->EOF){
				
				$this_id=db_field($rs,'hostgroup_object_id');
				if($this_id!=$last_id){
					if($last_id>0){
						echo "    </members>\n";
						echo "  </hostgroup>\n";
						}
					echo "  <hostgroup id='".db_field($rs,'hostgroup_object_id')."'>\n";
					xml_db_field(2,$rs,'instance_id');
					xml_db_field(2,$rs,'hostgroup_name');
					echo "    <members>\n";
					}
				echo "      <host id='".db_field($rs,'host_object_id')."'>\n";
				xml_db_field(4,$rs,'host_name');
				echo "      </host>\n";
					
				$last_id=$this_id;

				$rs->MoveNext();
				}
			if($last_id>0){
				echo "    </members>\n";
				echo "  </hostgroup>\n";
				}
			}

		echo "</hostgrouplist>\n";
		}
	}
	
// SERVICEGROUPS *************************************************************************
function fetch_servicegroups(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;

	$brevity=intval(grab_request_var("brevity",0));
	
	// default to only showing active objects unless overriden by request
	if(!isset($request["is_active"]))
		$request["is_active"]=1;

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["objects"].".instance_id",
		"servicegroup_id" => $db_tables[DB_NDOUTILS]["objects"].".object_id",
		"servicegroup_name" => $db_tables[DB_NDOUTILS]["objects"].".name1",
		"is_active" => $db_tables[DB_NDOUTILS]["objects"].".is_active",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"servicegroup_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetServiceGroups'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	$sql=generate_sql_query(DB_NDOUTILS,$args);
	//echo "SQL: ".$sql."<BR>\n";
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<servicegrouplist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			while(!$rs->EOF){
				
				echo "  <servicegroup id='".db_field($rs,'object_id')."'>\n";
				xml_db_field(2,$rs,'instance_id');
				xml_db_field(2,$rs,'name1','servicegroup_name');
				xml_db_field(2,$rs,'is_active');
				xml_db_field(2,$rs,'config_type');
				xml_db_field(2,$rs,'alias');
				echo "  </servicegroup>\n";

				$rs->MoveNext();
				}
			}

		echo "</servicegrouplist>\n";
		}
	}


// SERVICEGROUP MEMBERS **********************************************************************
function fetch_servicegroupmembers(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;
	
	$brevity=intval(grab_request_var("brevity",0));

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["servicegroups"].".instance_id",
		"servicegroup_id" => $db_tables[DB_NDOUTILS]["servicegroups"].".servicegroup_object_id",
		"servicegroup_name" => "obj1.name1",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"servicegroup_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetServiceGroupMembers'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	// override sort order, as its critical in the membership list logic below...
	$request["orderby"]="servicegroup_name";

	$sql=generate_sql_query(DB_NDOUTILS,$args);
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<servicegrouplist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			$last_id=0;
			$this_id=0;
			while(!$rs->EOF){
				
				$this_id=db_field($rs,'servicegroup_object_id');
				if($this_id!=$last_id){
					if($last_id>0){
						echo "    </members>\n";
						echo "  </servicegroup>\n";
						}
					echo "  <servicegroup id='".db_field($rs,'servicegroup_object_id')."'>\n";
					xml_db_field(2,$rs,'instance_id');
					xml_db_field(2,$rs,'servicegroup_name');
					echo "    <members>\n";
					}
				echo "      <service id='".db_field($rs,'service_object_id')."'>\n";
				xml_db_field(4,$rs,'host_name');
				xml_db_field(4,$rs,'service_description');
				echo "      </service>\n";
					
				$last_id=$this_id;

				$rs->MoveNext();
				}
			if($last_id>0){
				echo "    </members>\n";
				echo "  </servicegroup>\n";
				}
			}

		echo "</servicegrouplist>\n";
		}
	}
	
// SERVICEGROUP HOST MEMBERS **********************************************************************
function fetch_servicegrouphostmembers(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;
	
	$brevity=intval(grab_request_var("brevity",0));

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["servicegroups"].".instance_id",
		"servicegroup_id" => $db_tables[DB_NDOUTILS]["servicegroups"].".servicegroup_object_id",
		"servicegroup_name" => "obj1.name1",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"servicegroup_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetServiceGroupHostMembers'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	// override sort order, as its critical in the membership list logic below...
	$request["orderby"]="servicegroup_name";

	$sql=generate_sql_query(DB_NDOUTILS,$args);
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<servicegrouplist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			$last_id=0;
			$this_id=0;
			while(!$rs->EOF){
				
				$this_id=db_field($rs,'servicegroup_object_id');
				if($this_id!=$last_id){
					if($last_id>0){
						echo "    </members>\n";
						echo "  </servicegroup>\n";
						}
					echo "  <servicegroup id='".db_field($rs,'servicegroup_object_id')."'>\n";
					xml_db_field(2,$rs,'instance_id');
					xml_db_field(2,$rs,'servicegroup_name');
					echo "    <members>\n";
					}
				echo "      <host id='".db_field($rs,'host_object_id')."'>\n";
				xml_db_field(4,$rs,'host_name');
				echo "      </host>\n";
					
				$last_id=$this_id;

				$rs->MoveNext();
				}
			if($last_id>0){
				echo "    </members>\n";
				echo "  </servicegroup>\n";
				}
			}

		echo "</servicegrouplist>\n";
		}
	}
	
	
// CONTACTGROUPS *************************************************************************
function fetch_contactgroups(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;

	$brevity=intval(grab_request_var("brevity",0));
	
	// default to only showing active objects unless overriden by request
	if(!isset($request["is_active"]))
		$request["is_active"]=1;

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["objects"].".instance_id",
		"contactgroup_id" => $db_tables[DB_NDOUTILS]["objects"].".object_id",
		"contactgroup_name" => $db_tables[DB_NDOUTILS]["objects"].".name1",
		"is_active" => $db_tables[DB_NDOUTILS]["objects"].".is_active",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"contactgroup_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetContactGroups'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	$sql=generate_sql_query(DB_NDOUTILS,$args);
	//echo "SQL: ".$sql."<BR>\n";
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<contactgrouplist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			while(!$rs->EOF){
				
				echo "  <contactgroup id='".db_field($rs,'object_id')."'>\n";
				xml_db_field(2,$rs,'instance_id');
				xml_db_field(2,$rs,'name1','contactgroup_name');
				xml_db_field(2,$rs,'is_active');
				xml_db_field(2,$rs,'config_type');
				xml_db_field(2,$rs,'alias');
				echo "  </contactgroup>\n";

				$rs->MoveNext();
				}
			}

		echo "</contactgrouplist>\n";
		}
	}


// CONTACTGROUP MEMBERS **********************************************************************
function fetch_contactgroupmembers(){
	global $DB;
	global $cfg;
	global $sqlquery;
	global $db_tables;
	global $request;
	
	$brevity=intval(grab_request_var("brevity",0));

	// generate query
	$fieldmap=array(
		"instance_id" => $db_tables[DB_NDOUTILS]["contactgroups"].".instance_id",
		"contactgroup_id" => $db_tables[DB_NDOUTILS]["contactgroups"].".contactgroup_object_id",
		"contactgroup_name" => "obj1.name1",
		"config_type" => $db_tables[DB_NDOUTILS]["objects"].".config_type"
		);
	$objectauthfields=array(
		"contactgroup_id"
		);
	$instanceauthfields=array(
		"instance_id"
		);
	$args=array(
		"sql" => $sqlquery['GetContactGroupMembers'],
		"fieldmap" => $fieldmap,
		"objectauthfields" => $objectauthfields,
		"objectauthperms" => P_READ,
		"instanceauthfields" => $instanceauthfields,
		);
	// override sort order, as its critical in the membership list logic below...
	$request["orderby"]="contactgroup_name";

	$sql=generate_sql_query(DB_NDOUTILS,$args);
	if(!($rs=$DB[DB_NDOUTILS]->Execute($sql)))
		handle_backend_db_error(DB_NDOUTILS);
	else{
		output_backend_header();
		
		
		echo "<contactgrouplist>\n";
		echo "  <recordcount>".$rs->RecordCount()."</recordcount>\n";
		
		if(!isset($request["totals"])){
			$last_id=0;
			$this_id=0;
			while(!$rs->EOF){
				
				$this_id=db_field($rs,'contactgroup_object_id');
				if($this_id!=$last_id){
					if($last_id>0){
						echo "    </members>\n";
						echo "  </contactgroup>\n";
						}
					echo "  <contactgroup id='".db_field($rs,'contactgroup_object_id')."'>\n";
					xml_db_field(2,$rs,'instance_id');
					xml_db_field(2,$rs,'contactgroup_name');
					echo "    <members>\n";
					}
				echo "      <contact id='".db_field($rs,'contact_object_id')."'>\n";
				xml_db_field(4,$rs,'contact_name');
				echo "      </contact>\n";
					
				$last_id=$this_id;

				$rs->MoveNext();
				}
			if($last_id>0){
				echo "    </members>\n";
				echo "  </contactgroup>\n";
				}
			}

		echo "</contactgrouplist>\n";
		}
	}
	
	

?>